"use strict";
/*
 * Copyright (c) 2020 Broadcom.
 * The term "Broadcom" refers to Broadcom Inc. and/or its subsidiaries.
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Broadcom, Inc. - initial API and implementation
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Stage = void 0;
const EndevorEntity_1 = require("./EndevorEntity");
class Stage extends EndevorEntity_1.EndevorEntity {
    constructor(repo, stage) {
        super();
        this.envName = stage.envName;
        this.stgName = stage.stgName;
        this.stgId = stage.stgId;
        this.stgNum = stage.stgNum;
        this.repository = repo;
    }
    getName() {
        return this.stgNum.toString();
    }
    getDescription() {
        return '';
    }
    getRepository() {
        return this.repository;
    }
    getStgName() {
        return this.stgName;
    }
    getStgId() {
        return this.stgId;
    }
    getStgNum() {
        return this.stgNum;
    }
}
exports.Stage = Stage;
//# sourceMappingURL=Stage.js.map